#include <stdio.h>

int gamefield[3][3];
/*
0 - empty 
1 - x
-1 - o
*/


void
printfield ()
{
  int i, j;
  for (i = 0; i < 3; i++)
    {
      for (j = 0; j < 3; j++)
	if (gamefield[i][j] == 1)
	  putchar ('x');
	else if (gamefield[i][j] == -1)
	  putchar ('o');
	else
	  putchar ('.');
      putchar ('\n');
    }
}

int
checkwin (int who)
{
  int i;
  for (i = 0; i < 3; i++)
    if (gamefield[i][0] == who && gamefield[i][1] == who
	&& gamefield[i][2] == who)
      return 1;
  for (i = 0; i < 3; i++)
    if (gamefield[0][i] == who && gamefield[1][i] == who
	&& gamefield[2][i] == who)
      return 1;
  if (gamefield[0][0] == who && gamefield[1][1] == who
      && gamefield[2][2] == who)
    return 1;
  if (gamefield[2][0] == who && gamefield[1][1] == who
      && gamefield[0][2] == who)
    return 1;
  return 0;
}

int
nextmove (int who)
/*
who:
1 - x
-1 - o
returns:
0 - draw
-1 - lose
1 - win
*/
{
  int win, i, j, candraw = 0, canmove = 0;
  if (checkwin (-who)) return -1;
  /* we do not check if we have won, as
     it would be checked after our previous move */
  for (i = 0; i < 3; i++)
    for (j = 0; j < 3; j++)
      if (gamefield[i][j] == 0)
	{
	  canmove = 1;
	  gamefield[i][j] = who;
          win = nextmove (-who);
          if (win == 0)
  	   candraw = 1;
	  if (win == -1)
	  {
	    gamefield[i][j] = 0;
	    printfield ();
            printf ("%c can win by going %d %d\n\n", (who == 1) ? 'x' : 'o',i,j);
	    return 1;
	  }
	  gamefield[i][j] = 0;
	}
  printfield ();
  if (!canmove || candraw)
    {
      printf ("%c can draw\n\n", (who == 1) ? 'x' : 'o');
      return 0;
    }
  printf ("%c must lose\n\n", (who == 1) ? 'x' : 'o');
  return -1;
}

int
main ()
{
  int result;
  gamefield[1][1] = 1;
  gamefield[0][1] = -1;
  result = nextmove (1);
  printf ("Result: %d\n", result);
  return 0;
}
